<?php
/**
 * Wizard controller
 *
 * @package Focuspoint\Controller\Wizard
 * @author  Tim Lochmüller
 */

namespace HDNET\Focuspoint\Controller\Wizard;

use HDNET\Focuspoint\Utility\FileUtility;
use TYPO3\CMS\Backend\Utility\BackendUtility;
use TYPO3\CMS\Core\Database\DatabaseConnection;
use TYPO3\CMS\Core\Utility\ExtensionManagementUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Utility\HttpUtility;
use TYPO3\CMS\Fluid\View\StandaloneView;

/**
 * Wizard controller
 *
 * @author Tim Lochmüller
 */
class FocuspointController {

	/**
	 * Main action
	 *
	 * @throws \Exception
	 */
	public function main() {
		$parameter = GeneralUtility::_GET();
		$fileObject = FileUtility::getFileByMetaData((int)$parameter['P']['uid']);

		if (isset($parameter['save']) && $fileObject) {
			$values = array(
				'focus_point_y' => $parameter['yValue'] * 100,
				'focus_point_x' => $parameter['xValue'] * 100,
			);
			$uid = (int)$parameter['P']['uid'];
			$this->getDatabaseConnection()
				->exec_UPDATEquery('sys_file_metadata', 'uid=' . $uid, $values);
			HttpUtility::redirect($parameter['P']['returnUrl']);
		}

		$saveArguments = array(
			'save' => 1,
			'P'    => array(
				'uid'       => $parameter['P']['uid'],
				'returnUrl' => $parameter['P']['returnUrl'],
			)
		);
		$saveUri = BackendUtility::getModuleUrl('focuspoint', $saveArguments);

		$template = new StandaloneView();
		$template->setTemplatePathAndFilename(ExtensionManagementUtility::extPath('focuspoint', 'Resources/Private/Templates/Wizard/Focuspoint.html'));
		$template->assign('filePath', $fileObject->getPublicUrl(TRUE));
		$template->assign('saveUri', $saveUri);

		echo $template->render();
	}

	/**
	 * Get database connection
	 *
	 * @return DatabaseConnection
	 */
	protected function getDatabaseConnection() {
		return $GLOBALS['TYPO3_DB'];
	}
}
